package com.hipme.flipper;

import danger.audio.RingToneObject;
import danger.util.StringUtils;
import danger.util.StringTokenizer;
import danger.util.DEBUG;

class Friend {
  String name;
  RingToneObject tone;
  boolean blocked = false;
  boolean provideLocation = false;
  int uid;

  Friend() { }
  Friend(String name, RingToneObject tone, boolean blocked, boolean provideLocation) { 
    this.name=name; 
    this.tone=tone;
    this.blocked=blocked;
    this.provideLocation = provideLocation;
  }

  String getName() { return name; }
  RingToneObject getTone() { return tone; }
  void setTone(RingToneObject tone) { this.tone=tone; }
  boolean isBlocked() { return blocked; }
  void setIsBlocked(boolean blocked) { this.blocked=blocked; }
  void setProvideLocation(boolean provideLocation) { this.provideLocation=provideLocation; }
  boolean getProvideLocation() { return provideLocation; }
  int getUID() { return uid; }
  void setUID(int uid) { this.uid=uid; }


  Friend(byte[] record) {
    StringTokenizer st = new StringTokenizer(new String(record), "=&");
    while (st.hasMoreTokens()) {
      String key = st.nextToken();
      if (!st.hasMoreTokens()) 
	break; // protect against missing values
      String value = st.nextToken();
      if (key.equals("name")) {
	name = value;
      } else if (key.equals("toneID")) {
	tone = new RingToneObject();
	tone.setID(StringUtils.toInt(value));
      } else if (key.equals("toneFilterFlags")) {
	tone.setFilterFlags(StringUtils.toInt(value));
      } else if (key.equals("blocked")) {
	blocked = value.equalsIgnoreCase("true");
      } else if (key.equals("provideLocation")) {
	provideLocation = value.equalsIgnoreCase("true");
      } else {
	DEBUG.p("flipper: unknown Friend key " + key + " value="+value);
      }
    }
  }

  byte[] getBytes() {
    if (blocked) {
      return("blocked=true".getBytes());
    } else {
      StringBuffer sb = new StringBuffer();
      sb.append("name=");
      sb.append(name);
      sb.append("&toneID=");
      sb.append(tone.getID());
      sb.append("&toneFilterFlags=");
      sb.append(tone.getFilterFlags());
      if (provideLocation) 
	sb.append("&provideLocation=true");
      return sb.toString().getBytes();
    }
  }

}
