// Copyright 2003 Leigh L. Klotz, Jr.

package com.hipme.flipper;

import danger.app.Application;
import danger.app.Listener;
import danger.app.Event;
import danger.ui.View;
import danger.ui.TypeAheadTextField;
import danger.util.TextFinder;
import danger.ui.ListSelectMenu;
import danger.util.DEBUG;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import danger.ui.MenuItem;


public class FriendTextField extends TypeAheadTextField {
  // If we don't set the listener to null, then events go around and around
  // and we get multiple RETURNs in forms, and in the simulator, if you
  // press WHEEL it goes into an infinite loop.
  public void setListener(danger.ui.View view) {
    super.setListener(null);
  }
  public FriendTextField() {
    super(new FriendTextFinder());
  }
}

class FriendTextFinder extends Listener implements TextFinder {
  public final void search(ListSelectMenu menu, String inKey) {
    if (inKey.length() > 0) {
      Hashtable friends = Friends.getFriends();
      Vector v = new Vector();
      Enumeration e = friends.keys();
      while (e.hasMoreElements()) {
	String name = (String)(e.nextElement());
	if (name.startsWith(inKey)) {
	  v.addElement(new MenuItem(name));
	}
      }
      menu.updateMenuContents(v);
    } else {
      menu.updateMenuContents(new MenuItem[0]);
    }
  }
}
