package com.hipme.flipper;

import danger.app.*;
import danger.internal.Date;
import danger.ui.*;
import danger.system.*;
import java.util.Vector;
import danger.util.DEBUG;

class InputLine extends TextField implements Events, Resources, Constants {
  FlipWindow flipWindow;

  InputLine(FlipWindow flipWindow) {
    this.flipWindow = flipWindow;
		
    setAllowCursorBlink(true);
    setAutoText(true);
    setAutoCap(true);
  }
	
  public void setText(String value)
  {
    super.setText(value);
    invalidate();
  }
	
  public boolean eventKeyUp(char c, Event event) {
    boolean consumed = super.eventKeyUp(c, event);
    if (c == 13) consumed = flipOut();
    return consumed;
  }
	
  public boolean eventWidgetUp(int widget, Event event) {
    boolean consumed = false;

    switch (widget) {
    case Event.DEVICE_WHEEL_BUTTON:
      super.eventWidgetUp(widget, event);
      consumed = flipOut();
      break;
    }
    return (consumed || super.eventWidgetUp(widget, event));
  }


  boolean flipOut() {
    boolean consumed = false;
    String value = getStringCRLF();
    if (!value.equals("")) 
      consumed = flipWindow.flipOut(WHAT_MESSAGE, value);
    setText(null);
    return consumed;
  }
}
