// Copyright (c) 2003, 2004 Leigh L. Klotz, Jr. <klotz@graflex.org>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

package com.hipme.flipper;
import danger.app.*;
import danger.ui.*;
import danger.util.*;

class HistoryView extends ListView
{
  final static int MAX_WIDTH_CHARS=48;
  HistoryView() {
    setHasScrollbar(true);
  }
	
  public void myAddItem(String item) {
    DEBUG.p(this + " addItem " + item);
    int i = 0;
    while (true) {
      int end = i + MAX_WIDTH_CHARS;
      if (end > item.length()) {
	addItem(item.substring(i));
	break;
      } else {
	addItem(item.substring(i, i+MAX_WIDTH_CHARS));
      }
      i += MAX_WIDTH_CHARS;
    }
    advanceHilite(itemCount());
    invalidate();
  }
}
